// Code generated by protoc-gen-go-grpc. DO NOT EDIT.

package freeje_admin

import (
	context "context"
	api "gitlab.com/BetaCompany/Freeje/sdk/go/api"
	grpc "google.golang.org/grpc"
	codes "google.golang.org/grpc/codes"
	status "google.golang.org/grpc/status"
)

// This is a compile-time assertion to ensure that this generated file
// is compatible with the grpc package it is being compiled against.
// Requires gRPC-Go v1.32.0 or later.
const _ = grpc.SupportPackageIsVersion7

// PaymentClient is the client API for Payment service.
//
// For semantics around ctx use and closing/ending streaming RPCs, please refer to https://pkg.go.dev/google.golang.org/grpc/?tab=doc#ClientConn.NewStream.
type PaymentClient interface {
	//Получить список возможных методов пополнения
	Methods(ctx context.Context, in *api.RequestMode, opts ...grpc.CallOption) (Payment_MethodsClient, error)
	//Обновить данные о методе
	Update(ctx context.Context, in *Method, opts ...grpc.CallOption) (*Method, error)
	//Запускает синхронизацию методов с платежным шлюзом
	Sync(ctx context.Context, in *api.Empty, opts ...grpc.CallOption) (*api.Empty, error)
}

type paymentClient struct {
	cc grpc.ClientConnInterface
}

func NewPaymentClient(cc grpc.ClientConnInterface) PaymentClient {
	return &paymentClient{cc}
}

func (c *paymentClient) Methods(ctx context.Context, in *api.RequestMode, opts ...grpc.CallOption) (Payment_MethodsClient, error) {
	stream, err := c.cc.NewStream(ctx, &Payment_ServiceDesc.Streams[0], "/com.freeje.api.admin.Payment/Methods", opts...)
	if err != nil {
		return nil, err
	}
	x := &paymentMethodsClient{stream}
	if err := x.ClientStream.SendMsg(in); err != nil {
		return nil, err
	}
	if err := x.ClientStream.CloseSend(); err != nil {
		return nil, err
	}
	return x, nil
}

type Payment_MethodsClient interface {
	Recv() (*Method, error)
	grpc.ClientStream
}

type paymentMethodsClient struct {
	grpc.ClientStream
}

func (x *paymentMethodsClient) Recv() (*Method, error) {
	m := new(Method)
	if err := x.ClientStream.RecvMsg(m); err != nil {
		return nil, err
	}
	return m, nil
}

func (c *paymentClient) Update(ctx context.Context, in *Method, opts ...grpc.CallOption) (*Method, error) {
	out := new(Method)
	err := c.cc.Invoke(ctx, "/com.freeje.api.admin.Payment/Update", in, out, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

func (c *paymentClient) Sync(ctx context.Context, in *api.Empty, opts ...grpc.CallOption) (*api.Empty, error) {
	out := new(api.Empty)
	err := c.cc.Invoke(ctx, "/com.freeje.api.admin.Payment/Sync", in, out, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

// PaymentServer is the server API for Payment service.
// All implementations should embed UnimplementedPaymentServer
// for forward compatibility
type PaymentServer interface {
	//Получить список возможных методов пополнения
	Methods(*api.RequestMode, Payment_MethodsServer) error
	//Обновить данные о методе
	Update(context.Context, *Method) (*Method, error)
	//Запускает синхронизацию методов с платежным шлюзом
	Sync(context.Context, *api.Empty) (*api.Empty, error)
}

// UnimplementedPaymentServer should be embedded to have forward compatible implementations.
type UnimplementedPaymentServer struct {
}

func (UnimplementedPaymentServer) Methods(*api.RequestMode, Payment_MethodsServer) error {
	return status.Errorf(codes.Unimplemented, "method Methods not implemented")
}
func (UnimplementedPaymentServer) Update(context.Context, *Method) (*Method, error) {
	return nil, status.Errorf(codes.Unimplemented, "method Update not implemented")
}
func (UnimplementedPaymentServer) Sync(context.Context, *api.Empty) (*api.Empty, error) {
	return nil, status.Errorf(codes.Unimplemented, "method Sync not implemented")
}

// UnsafePaymentServer may be embedded to opt out of forward compatibility for this service.
// Use of this interface is not recommended, as added methods to PaymentServer will
// result in compilation errors.
type UnsafePaymentServer interface {
	mustEmbedUnimplementedPaymentServer()
}

func RegisterPaymentServer(s grpc.ServiceRegistrar, srv PaymentServer) {
	s.RegisterService(&Payment_ServiceDesc, srv)
}

func _Payment_Methods_Handler(srv interface{}, stream grpc.ServerStream) error {
	m := new(api.RequestMode)
	if err := stream.RecvMsg(m); err != nil {
		return err
	}
	return srv.(PaymentServer).Methods(m, &paymentMethodsServer{stream})
}

type Payment_MethodsServer interface {
	Send(*Method) error
	grpc.ServerStream
}

type paymentMethodsServer struct {
	grpc.ServerStream
}

func (x *paymentMethodsServer) Send(m *Method) error {
	return x.ServerStream.SendMsg(m)
}

func _Payment_Update_Handler(srv interface{}, ctx context.Context, dec func(interface{}) error, interceptor grpc.UnaryServerInterceptor) (interface{}, error) {
	in := new(Method)
	if err := dec(in); err != nil {
		return nil, err
	}
	if interceptor == nil {
		return srv.(PaymentServer).Update(ctx, in)
	}
	info := &grpc.UnaryServerInfo{
		Server:     srv,
		FullMethod: "/com.freeje.api.admin.Payment/Update",
	}
	handler := func(ctx context.Context, req interface{}) (interface{}, error) {
		return srv.(PaymentServer).Update(ctx, req.(*Method))
	}
	return interceptor(ctx, in, info, handler)
}

func _Payment_Sync_Handler(srv interface{}, ctx context.Context, dec func(interface{}) error, interceptor grpc.UnaryServerInterceptor) (interface{}, error) {
	in := new(api.Empty)
	if err := dec(in); err != nil {
		return nil, err
	}
	if interceptor == nil {
		return srv.(PaymentServer).Sync(ctx, in)
	}
	info := &grpc.UnaryServerInfo{
		Server:     srv,
		FullMethod: "/com.freeje.api.admin.Payment/Sync",
	}
	handler := func(ctx context.Context, req interface{}) (interface{}, error) {
		return srv.(PaymentServer).Sync(ctx, req.(*api.Empty))
	}
	return interceptor(ctx, in, info, handler)
}

// Payment_ServiceDesc is the grpc.ServiceDesc for Payment service.
// It's only intended for direct use with grpc.RegisterService,
// and not to be introspected or modified (even as a copy)
var Payment_ServiceDesc = grpc.ServiceDesc{
	ServiceName: "com.freeje.api.admin.Payment",
	HandlerType: (*PaymentServer)(nil),
	Methods: []grpc.MethodDesc{
		{
			MethodName: "Update",
			Handler:    _Payment_Update_Handler,
		},
		{
			MethodName: "Sync",
			Handler:    _Payment_Sync_Handler,
		},
	},
	Streams: []grpc.StreamDesc{
		{
			StreamName:    "Methods",
			Handler:       _Payment_Methods_Handler,
			ServerStreams: true,
		},
	},
	Metadata: "admin/payment.proto",
}
